import acm.program.*;

public class AnagramTest extends ConsoleProgram {

	public void run() {
		while (true) {
			String s1 = readLine("String 1: ");
			if (s1.length() == 0) break;
			String s2 = readLine("String 2: ");
			println("Those strings " + (isAnagram(s1, s2) ? "are" : "are not") + " anagrams");
		}
	}

/** Returns true if s1 and s2 are anagrams of each other */
	private boolean isAnagram(String s1, String s2) {
		int[] table1 = createFrequencyTable(s1);
		int[] table2 = createFrequencyTable(s2);
		for (int i = 0; i < table1.length; i++) {
			if (table1[i] != table2[i]) return false;
		}
		return true;
	}

/** Creates a letter-frequency table for the string */
	private int[] createFrequencyTable(String str) {
		int[] letterCounts = new int[26];
		for (char ch = 'A'; ch <= 'Z'; ch++) {
			letterCounts[ch - 'A'] = 0;
		}
		for (int i = 0; i < str.length(); i++) {
			char ch = str.charAt(i);
			if (Character.isLetter(ch)) {
				letterCounts[Character.toUpperCase(ch) - 'A']++;
			}
		}
		return letterCounts;
	}
	
	public static void main(String[] args) {
		new AnagramTest().start(args);
	}

}
